3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
49 # Resolve a path to be relative to another path. This is intended for
50 # converting submodule paths when git-submodule is run in a subdirectory
51 # and only handles paths where the directory separator is '/'.
53 # The output is the first argument as a path relative to the second argument,
54 # which defaults to $wt_prefix if it is omitted.
57 local target curdir result
59 curdir=${2-$wt_prefix}
63 while test -n "$curdir"
67 target=${target#"$curdir"/}
73 if test "$curdir" = "${curdir%/*}"
86 if test "$1" = "#unmatched"
93 # Print a submodule configuration setting
99 # Checks in the usual git-config places first (for overrides),
100 # otherwise it falls back on .gitmodules. This allows you to
101 # distribute project-wide defaults in .gitmodules, while still
102 # customizing individual repositories if necessary. If the option is
103 # not in .gitmodules either, print a default value.
105 get_submodule_config () {
109 value=$(git config submodule."$name"."$option")
112 value=$(git config -f .gitmodules submodule."$name"."$option")
114 printf '%s' "${value:-$default}"
119 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
122 # Sanitize the local git environment for use within a submodule. We
123 # can't simply use clear_local_git_env since we want to preserve some
124 # of the settings from GIT_CONFIG_PARAMETERS.
125 sanitize_submodule_env()
127 save_config=$GIT_CONFIG_PARAMETERS
129 GIT_CONFIG_PARAMETERS=$save_config
130 export GIT_CONFIG_PARAMETERS
134 # Add a new submodule to the working tree, .gitmodules and the index
138 # optional branch is stored in global branch variable
142 # parse $args after "submodule ... add".
148 case "$2" in '') usage ;; esac
159 case "$2" in '') usage ;; esac
164 reference_path="${1#--reference=}"
167 case "$2" in '') usage ;; esac
172 case "$2" in '') usage ;; esac
193 if test -n "$reference_path"
195 is_absolute_path "$reference_path" ||
196 reference_path="$wt_prefix$reference_path"
198 reference="--reference=$reference_path"
204 if test -z "$sm_path"; then
205 sm_path=$(printf '%s\n' "$repo" |
206 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
209 if test -z "$repo" || test -z "$sm_path"; then
213 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
215 # assure repo is absolute or relative to parent
218 test -z "$wt_prefix" ||
219 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
221 # dereference source url relative to parent's url
222 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
229 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
234 # multiple //; leading ./; /./; /../; trailing /
235 sm_path=$(printf '%s/\n' "$sm_path" |
245 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
246 die "$(eval_gettext "'\$sm_path' already exists in the index")"
248 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
250 eval_gettextln "The following path is ignored by one of your .gitignore files:
252 Use -f if you really want to add it." >&2
256 if test -n "$custom_name"
258 sm_name="$custom_name"
263 # perhaps the path exists and is already a git repo, else clone it
264 if test -e "$sm_path"
266 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
268 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
270 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
274 if test -d ".git/modules/$sm_name"
278 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
279 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
280 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
281 echo >&2 " $realrepo"
282 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
283 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
285 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
288 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
290 sanitize_submodule_env
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
294 '') git checkout -f -q ;;
295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
297 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
299 git config submodule."$sm_name".url "$realrepo"
301 git add $force "$sm_path" ||
302 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
304 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
305 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
308 git config -f .gitmodules submodule."$sm_name".branch "$branch"
310 git add --force .gitmodules ||
311 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
315 # Execute an arbitrary command sequence in each checked out
318 # $@ = command to execute
322 # parse $args after "submodule ... foreach".
344 # dup stdin so that it can be restored when running the external
345 # command in the subshell (and a recursive call to this function)
348 git submodule--helper list --prefix "$wt_prefix"|
349 while read mode sha1 stage sm_path
351 die_if_unmatched "$mode"
352 if test -e "$sm_path"/.git
354 displaypath=$(relative_path "$prefix$sm_path")
355 say "$(eval_gettext "Entering '\$displaypath'")"
356 name=$(git submodule--helper name "$sm_path")
358 prefix="$prefix$sm_path/"
359 sanitize_submodule_env
361 sm_path=$(relative_path "$sm_path") &&
362 # we make $path available to scripts ...
370 if test -n "$recursive"
372 cmd_foreach "--recursive" "$@"
375 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
381 # Register submodules in .git/config
383 # $@ = requested paths (default to all)
387 # parse $args after "submodule ... init".
408 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
412 # Unregister submodules from .git/config and remove their work tree
414 # $@ = requested paths (use '.' to deinit all submodules)
418 # parse $args after "submodule ... deinit".
446 if test -n "$deinit_all" && test "$#" -ne 0
448 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
451 if test $# = 0 && test -z "$deinit_all"
453 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
456 git submodule--helper list --prefix "$wt_prefix" "$@" |
457 while read mode sha1 stage sm_path
459 die_if_unmatched "$mode"
460 name=$(git submodule--helper name "$sm_path") || exit
462 displaypath=$(relative_path "$sm_path")
464 # Remove the submodule work tree (unless the user already did it)
465 if test -d "$sm_path"
467 # Protect submodules containing a .git directory
468 if test -d "$sm_path/.git"
470 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
471 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
476 git rm -qn "$sm_path" ||
477 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
480 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
481 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
484 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
486 # Remove the .git/config entries (unless the user already did it)
487 if test -n "$(git config --get-regexp submodule."$name\.")"
489 # Remove the whole section so we have a clean state when
490 # the user later decides to init this submodule again
491 url=$(git config submodule."$name".url)
492 git config --remove-section submodule."$name" 2>/dev/null &&
493 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
498 is_tip_reachable () (
499 sanitize_submodule_env &&
501 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
505 fetch_in_submodule () (
506 sanitize_submodule_env &&
512 git fetch $(get_default_remote) "$2" ;;
517 # Update each submodule path to correct revision, using clone and checkout as needed
519 # $@ = requested paths (default to all)
523 # parse $args after "submodule ... update".
546 case "$2" in '') usage ;; esac
547 reference="--reference=$2"
563 case "$2" in '') usage ;; esac
571 case "$2" in '') usage ;; esac
594 cmd_init "--" "$@" || return
598 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
599 ${wt_prefix:+--prefix "$wt_prefix"} \
600 ${prefix:+--recursive-prefix "$prefix"} \
601 ${update:+--update "$update"} \
602 ${reference:+--reference "$reference"} \
603 ${depth:+--depth "$depth"} \
605 "$@" || echo "#unmatched"
608 while read mode sha1 stage just_cloned sm_path
610 die_if_unmatched "$mode"
612 name=$(git submodule--helper name "$sm_path") || exit
613 url=$(git config submodule."$name".url)
614 branch=$(get_submodule_config "$name" branch master)
615 if ! test -z "$update"
617 update_module=$update
619 update_module=$(git config submodule."$name".update)
620 if test -z "$update_module"
622 update_module="checkout"
626 displaypath=$(relative_path "$prefix$sm_path")
628 if test $just_cloned -eq 1
631 update_module=checkout
633 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
634 git rev-parse --verify HEAD) ||
635 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
640 if test -z "$nofetch"
642 # Fetch remote before determining tracking $sha1
643 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
644 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
646 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
647 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
648 git rev-parse --verify "${remote_name}/${branch}") ||
649 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
652 if test "$subsha1" != "$sha1" || test -n "$force"
655 # If we don't already have a -f flag and the submodule has never been checked out
656 if test -z "$subsha1" && test -z "$force"
661 if test -z "$nofetch"
663 # Run fetch only if $sha1 isn't present or it
664 # is not reachable from a ref.
665 is_tip_reachable "$sm_path" "$sha1" ||
666 fetch_in_submodule "$sm_path" ||
667 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
669 # Now we tried the usual fetch, but $sha1 may
670 # not be reachable from any of the refs
671 is_tip_reachable "$sm_path" "$sha1" ||
672 fetch_in_submodule "$sm_path" "$sha1" ||
673 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
677 case "$update_module" in
679 command="git checkout $subforce -q"
680 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
681 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
685 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
686 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
687 must_die_on_failure=yes
691 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
692 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
693 must_die_on_failure=yes
696 command="${update_module#!}"
697 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
698 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
699 must_die_on_failure=yes
702 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
705 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
708 elif test -n "$must_die_on_failure"
710 die_with_status 2 "$die_msg"
712 err="${err};$die_msg"
717 if test -n "$recursive"
720 prefix=$(relative_path "$prefix$sm_path/")
722 sanitize_submodule_env
729 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
732 err="${err};$die_msg"
735 die_with_status $res "$die_msg"
760 sanitize_submodule_env
762 git describe "$2" 2>/dev/null ||
763 git describe --tags "$2" 2>/dev/null ||
764 git describe --contains "$2" 2>/dev/null ||
765 git describe --all --always "$2"
768 test -z "$revname" || revname=" ($revname)"
771 # Show commit summary for submodules in index or working tree
773 # If '--cached' is given, show summary between index and given commit,
774 # or between working tree and given commit
776 # $@ = [commit (default 'HEAD'),] requested paths (default all)
783 # parse $args after "submodule ... summary".
798 isnumber "$summary_limit" || usage
802 summary_limit="${1#--summary-limit=}"
803 isnumber "$summary_limit" || usage
819 test $summary_limit = 0 && return
821 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
825 elif test -z "$1" || test "$1" = "HEAD"
827 # before the first commit: compare with an empty tree
828 head=$(git hash-object -w -t tree --stdin </dev/null)
829 test -z "$1" || shift
837 die "$(gettext "The --cached option cannot be used with the --files option")"
843 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
844 # Get modified modules cared by user
845 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
846 sane_egrep '^:([0-7]* )?160000' |
847 while read mod_src mod_dst sha1_src sha1_dst status sm_path
849 # Always show modules deleted or type-changed (blob<->module)
850 if test "$status" = D || test "$status" = T
852 printf '%s\n' "$sm_path"
855 # Respect the ignore setting for --for-status.
856 if test -n "$for_status"
858 name=$(git submodule--helper name "$sm_path")
859 ignore_config=$(get_submodule_config "$name" ignore none)
860 test $status != A && test $ignore_config = all && continue
862 # Also show added or modified modules which are checked out
863 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
864 printf '%s\n' "$sm_path"
868 test -z "$modules" && return
870 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
871 sane_egrep '^:([0-7]* )?160000' |
873 while read mod_src mod_dst sha1_src sha1_dst status name
875 if test -z "$cached" &&
876 test $sha1_dst = 0000000000000000000000000000000000000000
880 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
882 100644 | 100755 | 120000)
883 sha1_dst=$(git hash-object $name)
889 eval_gettextln "unexpected mode \$mod_dst" >&2
896 test $mod_src = 160000 &&
897 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
900 test $mod_dst = 160000 &&
901 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
904 display_name=$(relative_path "$name")
907 case "$missing_src,$missing_dst" in
909 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
912 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
915 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
920 if test $mod_src = 160000 && test $mod_dst = 160000
922 range="$sha1_src...$sha1_dst"
923 elif test $mod_src = 160000
929 GIT_DIR="$name/.git" \
930 git rev-list --first-parent $range -- | wc -l
932 total_commits=" ($(($total_commits + 0)))"
936 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
937 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
940 blob="$(gettext "blob")"
941 submodule="$(gettext "submodule")"
942 if test $mod_dst = 160000
944 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
946 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
949 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
953 # Don't give error msg for modification whose dst is not submodule
954 # i.e. deleted or changed to blob
955 test $mod_dst = 160000 && echo "$errmsg"
957 if test $mod_src = 160000 && test $mod_dst = 160000
960 test $summary_limit -gt 0 && limit="-$summary_limit"
961 GIT_DIR="$name/.git" \
962 git log $limit --pretty='format: %m %s' \
963 --first-parent $sha1_src...$sha1_dst
964 elif test $mod_dst = 160000
966 GIT_DIR="$name/.git" \
967 git log --pretty='format: > %s' -1 $sha1_dst
969 GIT_DIR="$name/.git" \
970 git log --pretty='format: < %s' -1 $sha1_src
978 # List all submodules, prefixed with:
979 # - submodule not initialized
980 # + different revision checked out
982 # If --cached was specified the revision in the index will be printed
983 # instead of the currently checked out revision.
985 # $@ = requested paths (default to all)
989 # parse $args after "submodule ... status".
1016 git submodule--helper list --prefix "$wt_prefix" "$@" |
1017 while read mode sha1 stage sm_path
1019 die_if_unmatched "$mode"
1020 name=$(git submodule--helper name "$sm_path") || exit
1021 url=$(git config submodule."$name".url)
1022 displaypath=$(relative_path "$prefix$sm_path")
1023 if test "$stage" = U
1025 say "U$sha1 $displaypath"
1028 if test -z "$url" ||
1030 ! test -d "$sm_path"/.git &&
1031 ! test -f "$sm_path"/.git
1034 say "-$sha1 $displaypath"
1037 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1039 set_name_rev "$sm_path" "$sha1"
1040 say " $sha1 $displaypath$revname"
1042 if test -z "$cached"
1044 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1046 set_name_rev "$sm_path" "$sha1"
1047 say "+$sha1 $displaypath$revname"
1050 if test -n "$recursive"
1053 prefix="$displaypath/"
1054 sanitize_submodule_env
1059 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1064 # Sync remote urls for submodules
1065 # This makes the value for remote.$remote.url match the value
1066 # specified in .gitmodules.
1094 git submodule--helper list --prefix "$wt_prefix" "$@" |
1095 while read mode sha1 stage sm_path
1097 die_if_unmatched "$mode"
1098 name=$(git submodule--helper name "$sm_path")
1099 url=$(git config -f .gitmodules --get submodule."$name".url)
1101 # Possibly a url relative to parent
1104 # rewrite foo/bar as ../.. to find path from
1105 # submodule work tree to superproject work tree
1106 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1107 # guarantee a trailing /
1108 up_path=${up_path%/}/ &&
1109 # path from submodule work tree to submodule origin repo
1110 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1111 # path from superproject work tree to submodule origin repo
1112 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1115 sub_origin_url="$url"
1116 super_config_url="$url"
1120 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1122 displaypath=$(relative_path "$prefix$sm_path")
1123 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1124 git config submodule."$name".url "$super_config_url"
1126 if test -e "$sm_path"/.git
1129 sanitize_submodule_env
1131 remote=$(get_default_remote)
1132 git config remote."$remote".url "$sub_origin_url"
1134 if test -n "$recursive"
1136 prefix="$prefix$sm_path/"
1145 # This loop parses the command line arguments to find the
1146 # subcommand name to dispatch. Parsing of the subcommand specific
1147 # options are primarily done by the subcommand implementations.
1148 # Subcommand specific options such as --branch and --cached are
1149 # parsed here as well, for backward compatibility.
1151 while test $# != 0 && test -z "$command"
1154 add | foreach | init | deinit | update | status | summary | sync)
1184 # No command word defaults to "status"
1185 if test -z "$command"
1195 # "-b branch" is accepted only by "add"
1196 if test -n "$branch" && test "$command" != add
1201 # "--cached" is accepted only by "status" and "summary"
1202 if test -n "$cached" && test "$command" != status && test "$command" != summary